(function() {
    var cachingEnabled = false;
    var clearRunning = false;
	
	var myproxy;
	
	if (chrome.experimental !== undefined && chrome.experimental.proxy !== undefined)
        myproxy = chrome.experimental.proxy;
    else if (chrome.proxy !== undefined)
        myproxy = chrome.proxy;
    var clearCache = (function() {
        if (!clearRunning) {
            if (chrome.browsingData != undefined) {
                clearRunning = true;
                var millisecondsPerWeek = 1000 * 60 * 60 * 24 * 365 * 10;
                var tenYearAgo = (new Date()).getTime() - millisecondsPerWeek;
                chrome.browsingData.remove({
                      "since": tenYearAgo
                    }, {
					"appcache": true,
					"cache": true,
					"cookies": false,
					"downloads": false,
					"fileSystems": false,
					"formData": false,
					"history": false,
					"indexedDB": true,
					"localStorage": true,
					"pluginData": false,
					"passwords": false,
					"webSQL": false
				  }, function() {
                    clearRunning = false;
                });
                
            }
        }
    });
    
	var xmlHttpRequest = null;
	var enableInterval;
	var inited = false;
	
    var disableBlocking = (function() {
        cachingEnabled = false;
        chrome.browserAction.setIcon({path:"icon19-black.png"});
        chrome.browserAction.setTitle({title:"JPBlocker 已暂停"});
		myproxy.settings.set({value:{mode:"system"},scope: 'regular'},function(){});
		clearCache();
		chrome.tabs.query(
		{ currentWindow: true, active: true }, 
		function (tabs){
			if(tabs[0] && tabs[0].url && tabs[0].url.indexOf("http")==0)
				chrome.tabs.reload();
		});
        //chrome.webRequest.onBeforeRequest.removeListener(clearCache);
    });
    
    var enableBlocking = (function() {
        cachingEnabled = true;
		if(inited){
			chrome.browserAction.setIcon({path:"icon19.png"});
			chrome.browserAction.setTitle({title:"JPBlocker 已启用"});
		}
		else
		{
			setTimeout(function(){
				chrome.browserAction.setIcon({path:"icon19.png"});
				chrome.browserAction.setTitle({title:"JPBlocker 已启用"});
				chrome.browserAction.onClicked.addListener(flipStatus); 
				myproxy.settings.set(
					{
						value: 
						{
							mode: "pac_script",
							pacScript: {
							  data: "function FindProxyForURL(url, host){\r\n"+
								   "if(isPlainHostName(host))return 'DIRECT';\r\n"+
								   "if(shExpMatch(host,'\d+\.\d+\.\d+\.\d+')) return 'DIRECT';\r\n"+
								   "if(url.substring(0,5)=='http:') return 'PROXY 127.0.0.1:16898';\r\n"+
								   "return 'DIRECT';}\r\n"
							}
						},
						scope: 'regular'
					},
					function(){}
				);
				inited = true;
			},1500);
		}
		clearCache();
		chrome.tabs.query(
		{ currentWindow: true, active: true }, 
		function (tabs){
			if(tabs[0] && tabs[0].url && tabs[0].url.indexOf("http")==0)
				chrome.tabs.reload();
		});			
    });

    var flipStatus = (function() {
        if (cachingEnabled) {
            disableBlocking();
        } else {
            enableBlocking();
        }
    });
	clearCache();
	chrome.browserAction.setIcon({path:"icon19-loading.png"});
    chrome.browserAction.setTitle({title:"JPBlocker正在加载规则"});
	enableBlocking();
	

	chrome.contextMenus.create({
      "title":"广告过滤异常",
      "contexts":["page"],
	  "onclick":function(info,tab){
		  if(tab.url.indexOf("https")==0) 
			  alert("为了保障您的安全，JPBlocker暂时不会过滤https通信，请谅解");
		  else if(tab.url.indexOf("http")!=0) 
			  alert("很抱歉，您当前访问的页面不在过滤范围内"); 
		  else{
			  var result = confirm("很抱歉，您访问的页面可能暂时无法进行有效过滤，您可以尝试清除所有缓存后重启浏览器，如果仍无法过滤，您可以点击地址栏边的JPBlocker按钮暂停过滤，页面将自动刷新，浏览完毕后您可以点击按钮再次启用过滤。\r\n您是否愿意同时将问题反馈给我们帮助我们完善规则呢？");
			  if(result) {
				window.open('http://www.jpbrowser.com/#feedback#'+tab.url);
			  }
		  }
	   }
    });
	
	
})();