if (localStorage["options.padding"]) {
    document.write('<style type="text/css">');
    document.write("#pages li a {padding:" + localStorage["options.padding"] + "px; }");
    document.write("</style>")
}
$(function() {
    $("*[i18n]").each(function() {
        if (i18n($(this).attr("i18n"))) {
            $(this).html(i18n($(this).attr("i18n")))
        }
    })
});

function setBookmarksProvider(a) {
    setValue("options.sidebar.showGooglebookmarks", 0);
    setValue("options.sidebar.showBookmarks", 0);
    setValue("options.sidebar.showDelicious", 0);
    setValue("options.sidebar.showPinboard", 0);
    $(".bookmarks-provider").hide();
    switch (a) {
        case "chrome":
            setValue("options.sidebar.showBookmarks", 1);
            $(".bookmarks-provider").hide();
            $("#bookmarks-provider-chrome-settings").show();
            break;
        case "google":
            setValue("options.sidebar.showGooglebookmarks", 1);
            $(".bookmarks-provider").hide();
            $("#bookmarks-provider-google-settings").show();
            break;
        case "delicious":
            setValue("options.sidebar.showDelicious", 1);
            $(".bookmarks-provider").hide();
            $("#bookmarks-provider-delicious-settings").show();
            break;
        case "pinboard":
            setValue("options.sidebar.showPinboard", 1);
            $(".bookmarks-provider").hide();
            $("#bookmarks-provider-pinboard-settings").show();
            break
    }
}
$(function() {
    $(".bookmarks-provider").hide();
    if (getValue("options.sidebar.showBookmarks") == 1) {
        $("#bookmarks-provider-chrome").attr("checked", true)
    }
    if (getValue("options.sidebar.showDelicious") == 1) {
        $("#bookmarks-provider-delicious").attr("checked", true);
        $("#bookmarks-provider-delicious-settings").show()
    }
    if (getValue("options.sidebar.showGooglebookmarks") == 1) {
        $("#bookmarks-provider-google").attr("checked", true);
        $("#bookmarks-provider-google-settings").show()
    }
    if (getValue("options.sidebar.showPinboard") == 1) {
        $("#bookmarks-provider-pinboard").attr("checked", true);
        $("#bookmarks-provider-pinboard-settings").show()
    }
    if (getValue("options.sidebar.showBookmarksURL") == 1) {
        $("#options-sidebar-showbookmarksURL").attr("checked", true)
    }
    if (getValue("options.useGoogleBookmarksShortcut") == 1) {
        $("#options-useGoogleBookmarksShortcut").attr("checked", true)
    }
    if (getValue("options.useDeliciousShortcut") == 1) {
        $("#options-useDeliciousShortcut").attr("checked", true)
    }
    if (getValue("options.sidebar.deliciousUsername")) {
        $("#options-sidebar-delicious-username").val(getValue("options.sidebar.deliciousUsername"))
    }
    $("#options-sidebar-delicious-username").change(function() {
        setValue("options.sidebar.deliciousUsername", $(this).val())
    });
    if (getValue("options.sidebar.delicious.favoriteTags")) {
        $("#options-sidebar-delicious-favoriteTags").val(getValue("options.sidebar.delicious.favoriteTags"))
    }
    $("#options-sidebar-delicious-favoriteTags").change(function() {
        setValue("options.sidebar.delicious.favoriteTags", $(this).val())
    });
    if (getValue("options.usePinboardShortcut") == 1) {
        $("#options-usePinboardShortcut").attr("checked", true)
    }
    if (getValue("options.sidebar.pinboardUsername")) {
        $("#options-sidebar-pinboard-username").val(getValue("options.sidebar.pinboardUsername"))
    }
    $("#options-sidebar-pinboard-username").change(function() {
        setValue("options.sidebar.pinboardUsername", $(this).val());
        clearValue("_tmp_pinboard.tags")
    })
});
var preview = Array;
preview.bg = localStorage["options.colors.dialbg"];
preview.bgover = localStorage["options.colors.dialbgover"];
preview.bginner = localStorage["options.colors.dialbginner"];
preview.bginnerover = localStorage["options.colors.dialbginnerover"];
preview.border = localStorage["options.colors.border"];
preview.borderover = localStorage["options.colors.borderover"];
preview.title = localStorage["options.colors.title"];
preview.titleover = localStorage["options.colors.titleover"];
preview.titlealign = localStorage["options.titleAlign"];
preview.titlefontface = localStorage["options.fontface"];
preview.padding = localStorage["options.padding"];
preview.corners = localStorage["options.dialstyle.corners"];
preview.shadow = localStorage["options.dialstyle.shadow"];

function reloadCss() {
    $("#pages li a").css("background-color", preview.bg);
    $("#pages li a").css("border-color", preview.border);
    $("#pages li a").css("padding", preview.padding);
    $("#pages li a, .shadow").css("width", 420 - (12 - preview.padding));
    $("#pages li a").css("border-radius", preview.corners);
    $("#pages li .thumbnail_container").css("border-radius", preview.corners + "px " + preview.corners + "px 0 0");
    $("#pages li .thumbnail_container").css("background-color", preview.bginner);
    $("#pages li .title").css("color", preview.title);
    $("#pages li .title").css("text-align", preview.titlealign);
    $("#pages li .title").css("font-family", preview.titlefontface + "!important");
    if (preview.shadow != "none") {
        if (localStorage["options.dialstyle.shadow"] == "glow") {
            $("#pages li a").addClass("glowshadow");
            $(".shadow").css("visibility", "hidden")
        } else {
            $("#pages li .shadow").css("background", 'url("images/shadow_' + preview.shadow + '.png") no-repeat left top');
            $("#pages li a").removeClass("glowshadow");
            $(".shadow").css("visibility", "visible")
        }
    } else {
        $(".shadow").css("visibility", "hidden");
        $("#pages li a").removeClass("glowshadow")
    }
    $("#pages li a").hover(function() {
        $("#pages li a").css("background-color", preview.bgover);
        $("#pages li .thumbnail_container").css("background-color", preview.bginnerover);
        $("#pages li a").css("border-color", preview.borderover);
        $("#pages li .title").css("color", preview.titleover)
    }, function() {
        $("#pages li a").css("background-color", preview.bg);
        $("#pages li .thumbnail_container").css("background-color", preview.bginner);
        $("#pages li a").css("border-color", preview.border);
        $("#pages li .title").css("color", preview.title)
    })
}

function setPreview(c, a) {
    preview[c] = a;
    reloadCss()
}

function switchTab(a) {
    $(".tabs li").removeClass("selected");
    $(".tabs li[rel=" + a + "]").addClass("selected");
    $(".tab").hide();
    $("#" + a).show();
    window.location.hash = a;
    $("html").scrollTop();
    window.scrollTo(0, 0)
}

function showSection(a) {
    window.scroll(0, 0);
    $("#options_navigation li").removeClass("selected");
    $("#options_navigation li[rel=" + a + "]").addClass("selected");
    $(".options_tab").hide();
    $("#tab_" + a).show(0)
}

function tabsync() {
    window.scroll(0, 0);
    $(".options_tab_link").removeClass("selected");
    $("#sync_indicator").addClass("selected");
    $(".options_tab").hide();
    $("#tab_sync").show(0)
}
$(function() {
    $(".options_tab_link").click(function() {
        $(".options_tab_link").removeClass("selected");
        $(this).addClass("selected");
        $(".options_tab").hide();
        $("#tab_" + ($(this).attr("rel"))).show(0)
    });
    $("ul.tabs li").click(function() {
        switchTab($(this).attr("rel"))
    });
    $("#themes .bg").click(function() {
        m(this)
    });
    reloadCss();
    $("input[name=options-corners]").change(function() {
        setValue("options.dialstyle.corners", $(this).val());
        setPreview("corners", $(this).val())
    });
    $("input[name=options-dropShadow][value=" + getValue("options.dialstyle.shadow") + "]").attr("checked", "checked");
    $("input[name=options-titlePosition][value=" + getValue("options.dialstyle.titleposition") + "]").attr("checked", "checked");
    $("#options-fontface").change(function() {
        setValue("options.fontface", $(this).val());
        setPreview("titlefontface", $(this).val())
    });
    $("#options-fontsize").change(function() {
        setValue("options.fontsize", $(this).val())
    });
    $("#options-fontstyle").change(function() {
        setValue("options.fontstyle", $(this).val())
    });
    $("#options-colors-dialbg").val(getValue("options.colors.dialbg"));
    $("#options-colors-dialbg").change(function() {
        setValue("options.colors.dialbg", $(this).val());
        setPreview("bg", $(this).val())
    });
    $("#options-colors-dialbgover").val(getValue("options.colors.dialbgover"));
    $("#options-colors-dialbgover").change(function() {
        setValue("options.colors.dialbgover", $(this).val());
        setPreview("bgover", $(this).val())
    });
    $("#options-colors-dialbginner").val(getValue("options.colors.dialbginner"));
    $("#options-colors-dialbginner").change(function() {
        setValue("options.colors.dialbginner", $(this).val());
        setPreview("bginner", $(this).val())
    });
    $("#options-colors-dialbginnerover").val(getValue("options.colors.dialbginnerover"));
    $("#options-colors-dialbginnerover").change(function() {
        setValue("options.colors.dialbginnerover", $(this).val());
        setPreview("bginnerover", $(this).val())
    });
    $("#options-colors-border").val(getValue("options.colors.border"));
    $("#options-colors-border").change(function() {
        setValue("options.colors.border", $(this).val());
        setPreview("border", $(this).val())
    });
    $("#options-colors-borderover").val(getValue("options.colors.borderover"));
    $("#options-colors-borderover").change(function() {
        setValue("options.colors.borderover", $(this).val());
        setPreview("borderover", $(this).val())
    });
    $("#options-colors-title").val(getValue("options.colors.title"));
    $("#options-colors-title").change(function() {
        setValue("options.colors.title", $(this).val());
        setPreview("title", $(this).val())
    });
    $("#options-colors-titleover").val(getValue("options.colors.titleover"));
    $("#options-colors-titleover").change(function() {
        setValue("options.colors.titleover", $(this).val());
        setPreview("titleover", $(this).val())
    });
    if (getValue("options.corners") >= 0) {
        $("#options-corners").val(getValue("options.dialstyle.corners"));
        $("#options-corners-val").val(getValue("options.dialstyle.corners"))
    }
    $("#options-corners").change(function() {
        $("#options-corners-val").val($(this).val());
        setValue("options.dialstyle.corners", $(this).val());
        setPreview("corners", $(this).val())
    });
    if (getValue("options.padding") >= 0) {
        $("#options-padding").val(getValue("options.padding"));
        $("#options-padding-val").val(getValue("options.padding"))
    }
    $("#options-padding").change(function() {
        $("#options-padding-val").val($(this).val());
        setValue("options.padding", $(this).val());
        setPreview("padding", $(this).val())
    });
    if (getValue("options.sidebar") == 1) {
        $("#options-sidebar").attr("checked", true)
    }
    if (getValue("options.sidebaractivation") == "position") {
        $("#options-sidebaractivation-position").attr("checked", true)
    } else {
        $("#options-sidebaractivation-scroll").attr("checked", true)
    }
    if (getValue("options.sidebar.showHistory") == 1) {
        $("#options-sidebar-showhistory").attr("checked", true)
    }
    if (getValue("options.sidebar.showApps") == 1) {
        $("#options-sidebar-showapps").attr("checked", true)
    }
    if (getValue("options.apps.show") == 1) {
        $("#options-apps-show").attr("checked", true)
    }
    switch (getValue("options.apps.align")) {
        case "left":
            $("#options-apps-align-left").attr("checked", true);
            break;
        case "right":
            $("#options-apps-align-right").attr("checked", true);
            break;
        default:
            $("#options-apps-align-center").attr("checked", true)
    }
    switch (getValue("options.apps.position")) {
        case "top":
            $("#options-apps-position-top").attr("checked", true);
            break;
        default:
            $("#options-apps-position-bottom").attr("checked", true)
    }
    switch (getValue("options.apps.theme")) {
        case "transparent":
            $("#options-apps-theme-transparent").attr("checked", true);
            break;
        case "dark":
            $("#options-apps-theme-dark").attr("checked", true);
            break;
        default:
            $("#options-apps-theme-light").attr("checked", true)
    }
    switch (getValue("options.apps.iconsize")) {
        case "extrasmall":
            $("#options-apps-iconsize-extrasmall").attr("checked", true);
            break;
        case "small":
            $("#options-apps-iconsize-small").attr("checked", true);
            break;
        case "large":
            $("#options-apps-iconsize-large").attr("checked", true);
            break;
        default:
            $("#options-apps-iconsize-medium").attr("checked", true)
    }
    if (getValue("options.centerThumbnailsVertically") == 3) {
        $("#options-centerThumbnailsVertically3").attr("checked", true)
    } else {
        if (getValue("options.centerThumbnailsVertically") == 1) {
            $("#options-centerThumbnailsVertically1").attr("checked", "checked")
        } else {
            if (getValue("options.centerThumbnailsVertically") == 2) {
                $("#options-centerThumbnailsVertically2").attr("checked", true)
            } else {
                if (getValue("options.centerThumbnailsVertically") == 0) {
                    $("#options-centerThumbnailsVertically0").attr("checked", true)
                }
            }
        }
    }
    if (getValue("options.columns") >= 0) {
        $("#options-columns").val(getValue("options.columns"));
        $("#options-columns-val").val(getValue("options.columns"))
    }
    $("#options-columns").change(function() {
        $("#options-columns-val").val($(this).val());
        setValue("options.columns", $(this).val())
    });
    if (getValue("options.dialspacing") >= 0) {
        $("#options-dialspacing").val(getValue("options.dialspacing"));
        $("#options-dialspacing-val").val(getValue("options.dialspacing"))
    }
    $("#options-dialspacing").change(function() {
        $("#options-dialspacing-val").val($(this).val());
        setValue("options.dialspacing", $(this).val())
    });
    if (getValue("options.thumbnailRatio") >= 0) {
        $("#options-thumbnailRatio").val(getValue("options.thumbnailRatio"));
        $("#options-thumbnailRatio-val").val(getValue("options.thumbnailRatio"))
    }
    $("#options-thumbnailRatio").change(function() {
        $("#options-thumbnailRatio-val").val(Math.round($(this).val() * 100) / 100);
        setValue("options.thumbnailRatio", Math.round($(this).val() * 100) / 100)
    });
    resetThumbnailRatio = function() {
        $("#options-thumbnailRatio").val(1);
        $("#options-thumbnailRatio-val").val(1);
        setValue("options.thumbnailRatio", 1)
    };
    if (getValue("options.dialSpace") >= 0) {
        $("#options-dialspace").val(getValue("options.dialSpace"));
        $("#options-dialspace-val").val(getValue("options.dialSpace"))
    }
    $("#options-dialspace").change(function() {
        $("#options-dialspace-val").val($(this).val());
        setValue("options.dialSpace", $(this).val())
    });
    if (getValue("options.alwaysNewTab") == 1) {
        $("#options-alwaysNewTab").attr("checked", true)
    }
    if (getValue("options.showContextMenu") == 1) {
        $("#options-showContextMenu").attr("checked", true)
    }
    if (getValue("options.showVisits") == 1) {
        $("#options-showVisits").attr("checked", true)
    }
    if (getValue("options.showTitle") == 1) {
        $("#options-showTitle").attr("checked", true)
    }
    if (getValue("options.showFavicon") == 1) {
        $("#options-showFavicon").attr("checked", true)
    }
    if (getValue("options.showAddButton") == 1) {
        $("#options-showAddButton").attr("checked", true)
    }
    if (getValue("options.showOptionsButton") == 1) {
        $("#options-showOptionsButton").attr("checked", true)
    }
    if (getValue("options.keepActiveGroup") == 1) {
        $("#options-keepActiveGroup").attr("checked", true)
    }
    if (getValue("options.centerVertically") == 1) {
        $("#options-centervertically").attr("checked", true)
    }
    if (getValue("options.highlight") == 1) {
        $("#options-highlight").attr("checked", true)
    }
    if (getValue("options.order") == "visits") {
        $("#options-order-visits").attr("checked", true)
    } else {
        $("#options-order-position").attr("checked", true)
    }
    if (getValue("options.thumbnailQuality") == "low") {
        $("#options-thumbquality-low").attr("checked", true)
    } else {
        if (getValue("options.thumbnailQuality") == "high") {
            $("#options-thumbquality-high").attr("checked", true)
        } else {
            $("#options-thumbquality-medium").attr("checked", true)
        }
    }
    $("#options-columns").change(function() {
        setValue("options.columns", $(this).val())
    });
    $("#options-backgroundPosition").val(getValue("options.backgroundPosition"));
    $("#options-backgroundSize").val(getValue("options.backgroundSize"));
    $("#options-repeatbackground").val(getValue("options.repeatbackground"));
    $("#options-repeatbackground").change(function() {
        setValue("options.repeatbackground", $(this).val())
    });
    if (getValue("options.background")) {
        $("#options-background").val(getValue("options.background"))
    }
    if (getValue("options.fontsize")) {
        $("#options-fontsize").val(getValue("options.fontsize"))
    }
    if (getValue("options.fontface")) {
        $("#options-fontface").val(getValue("options.fontface"))
    }
    if (getValue("options.fontstyle")) {
        $("#options-fontstyle").val(getValue("options.fontstyle"))
    }
    if (getValue("options.customCss")) {
        $("#options-custom-css").val(getValue("options.customCss"))
    }
    $("#options-custom-css").blur(function() {
        setValue("options.customCss", $(this).val())
    });
    if (getValue("options.columns")) {
        $("#options-columns").val(getValue("options.columns"))
    }
    switch (getValue("options.titleAlign")) {
        case "left":
            $("#options-titleAlign-left").attr("checked", true);
            break;
        case "right":
            $("#options-titleAlign-right").attr("checked", true);
            break;
        default:
            $("#options-titleAlign-center").attr("checked", true)
    }
    switch (getValue("options.refreshThumbnails")) {
        case "10":
            $("#options-refreshThumbnails10").attr("checked", true);
            break;
        case "5":
            $("#options-refreshThumbnails5").attr("checked", true);
            break;
        case "2":
            $("#options-refreshThumbnails2").attr("checked", true);
            break;
        default:
            $("#options-refreshThumbnails0").attr("checked", true)
    }
    switch (getValue("options.scrollLayout")) {
        case "0":
            $("#options-scrollLayout0").attr("checked", true);
            break;
        default:
            $("#options-scrollLayout1").attr("checked", true)
    }
    $("#options-backgroundPosition").change(function() {
        setValue("options.backgroundPosition", $(this).val())
    });
    $("#options-backgroundSize").change(function() {
        setValue("options.backgroundSize", $(this).val())
    });
    $("#options-background").change(function() {
        setValue("options.background", $(this).val());
        setValue("options.backgroundPattern", "")
    });
    $("#options-colors-bg").val(getValue("options.colors.bg"));
    $("#options-colors-bg").change(function() {
        setValue("options.colors.bg", $(this).val())
    });

    function j(i) {
        $(".hide-premium").hide();
        $(".show-premium").show();
        $(".show-unregistered").hide();
        $(".hide-unregistered").show();
        $("#sync_indicator").find("img").remove();
        $("#sync_indicator").prepend('<img src="images/options.sync-indicator.png" /> ');
        $(".sync-status-username").text(getValue("options.sync.username"));
        $("#sync_status").html("Sync OK, last synchronization " + prettyDate(parseInt(i.last_sync)));
        if (null != i.groups && i.groups > 0) {
            $(".sync-status-groups").text(i.groups + " groups")
        }
        if (null != i.bookmarks && i.bookmarks > 0) {
            $(".sync-status-bookmarks").text(i.bookmarks + " bookmarks");
            $(".sync-status-text").show()
        }
    }

    function l() {
        $(".hide-premium").show();
        $(".show-premium").hide();
        $(".hide-unregistered").hide();
        $(".show-unregistered").show();
        $("#sync_indicator").find("img").remove();
        $("#sync_indicator").prepend('<img src="images/options.sync-indicator-false.png" />')
    }

    function e() {
        b.test_sync_account(function(i) {
            if (i.code > -1) {
                j(i)
            } else {
                l()
            }
        })
    }
    if (!getValue("options.sync.password") && !getValue("options.sync.password")) {
        l()
    } else {
        e()
    }
    var n = getValue("options.sync.password");
    var k = getValue("options.sync.username");
    if (k != "") {
        $("#options-sync-username").val(k)
    }
    if (n != "") {
        $("#options-sync-password").val(n)
    }
    $("#logout").click(function(i) {
        if (confirm("Are you sure you want to logout?")) {
            localStorage["options.sync.password"] = "";
            localStorage["options.sync.username"] = "";
            $("#options-sync-password").val("");
            $("#options-sync-username").val("");
            l();
            show_message("You have been signed out.", true, 400)
        }
    });

    function h() {
        var i = chrome.extension.getBackgroundPage();
        var q = speeddial.storage.sync_url();
        var p = $("#options-sync-password").val();
        var o = $("#options-sync-username").val();
        if (p != n) {
            n = Base64.encode(p)
        }
        if (o != k) {
            k = o
        }
        setValue("options.sync.username", k);
        setValue("options.sync.password", n);
        if (k != "" && n != "") {
            show_message("Connecting to sync server...", true, 50000);
            $.post(q + "/sync2/test", {
                username: localStorage.getItem("options.sync.username"),
                password: localStorage.getItem("options.sync.password")
            }, function(t) {
                if (t) {
                    switch (t.code) {
                        case 0:
                            show_message("Preparing initial sync...", true, 50000);
                            i.sync_to_server(function(u) {
                                if (u.code == 1) {
                                    setTimeout(function() {
                                        show_message("You sync account is connected...", true, 600);
                                        e()
                                    }, 2000)
                                } else {
                                    show_message("There was an error while importing your settings.", true, 2000)
                                }
                            });
                            break;
                        case 1:
                            speeddial.storage.open();
                            if (localStorage.getItem("options.sync.lastsync")) {
                                show_message("Please wait for synchronization to complete...", true, 100000);
                                i.sync(function() {
                                    show_message("Sync complete...", true, 600);
                                    e()
                                })
                            } else {
                                speeddial.storage.countBookmarksAndGroups(function(x, w) {
                                    if (x > 3 || w > 0) {
                                        var u = false;
                                        var v = localStorage.getItem("options.sync.password");
                                        setValue("options.sync.password", "");
                                        hide_message(0);
                                        $("#sync-conflict-warning").omniWindow({
                                            callbacks: {
                                                beforeShow: function(C, A) {
                                                    var B;
                                                    var y = C.modal.find('input[name="sync-preference"]:checked');
                                                    var z = C.modal.find("button[type=submit]");
                                                    y.removeAttr("checked");
                                                    z.unbind().on("click", function() {
                                                        B = C.modal.find('input[name="sync-preference"]:checked').val();
                                                        if (B == "1") {
                                                            u = false
                                                        } else {
                                                            if (B == "2") {
                                                                u = true
                                                            }
                                                        }
                                                        C.modal.trigger("hide");
                                                        if (B > 0) {
                                                            setValue("options.sync.password", v);
                                                            C.modal.trigger("hide");
                                                            show_message("Please wait for synchronization to complete...", true, 100000);
                                                            i.merge_or_sync(function() {
                                                                show_message("Sync complete...", true, 600);
                                                                setTimeout(function() {
                                                                    e()
                                                                }, 1000)
                                                            }, u)
                                                        }
                                                    });
                                                    return A(C)
                                                }
                                            }
                                        }).trigger("show")
                                    } else {
                                        i.merge_or_sync(function() {
                                            show_message("Please wait for synchronization to complete...", true, 100000);
                                            setTimeout(function() {
                                                show_message("Sync complete...", true, 600);
                                                e()
                                            }, 1000)
                                        }, false)
                                    }
                                })
                            }
                            break;
                        case -999:
                            show_message("Enter username and password", true, 2000);
                            localStorage.removeItem("options.sync.password");
                            var s = $("#options-sync-password").val("");
                            break;
                        case -99:
                            show_message("Wrong username, e-mail or password", true, 2000);
                            localStorage.removeItem("options.sync.password");
                            var s = $("#options-sync-password").val("");
                            break;
                        case -1:
                            show_message("Your sync account is not active. Please log in to activate it.", true, 3000);
                            break;
                        default:
                            hide_message();
                            break
                    }
                }
            }, "json").error(function() {
                show_message("There was an error while connecting to server.", true, 3000);
                localStorage.removeItem("options.sync.password")
            })
        } else {
            show_message("Enter username and password", true, 200);
            localStorage.removeItem("options.sync.password");
            var p = $("#options-sync-password").val("")
        }
    }
    $("#sync").on("click", function(i) {
        h();
        i.preventDefault()
    });
    $("#options-sync-password").keyup(function(i) {
        if (i.keyCode == 13) {
            h()
        }
    });

    function d(i) {
        $(".use-background").remove();
        $("#support").remove();
        $("#color-picker").remove();
        $("#main").css("margin-bottom", "300px");
        $("html").css("background", "url(" + $(i).data("url") + "),url(" + $(i).data("pattern") + ")").css("background-repeat", $(i).data("repeat")).css("background-position", $(i).data("position")).css("background-size", $(i).data("size")).css("background-color", $(i).data("color")).css("background-attachment", "fixed");
        $(i).append('<a class="btn use-background">确认使用此背景</a>');
        $(i).find("a").click(function() {
            m(i)
        });
        if ($(i).data("customizable")) {
            switchColor = $('<input id="color-picker" title="Customize background color" />');
            $(i).append(switchColor);
            myPicker = new jscolor.color(document.getElementById("color-picker"), {
                onImmediateChange: function(o) {
                    $(i).css("background-color", o);
                    $(i).data("selectedcolor", o.toString());
                    $("html").css("background-color", o)
                }
            });
            myPicker.fromString($(i).data("color"))
        }
    }

    function m(i) {
        setValue("options.background", $(i).data("url"));
        setValue("options.backgroundPattern", $(i).data("pattern"));
        setValue("options.backgroundPosition", $(i).data("position"));
        setValue("options.repeatbackground", $(i).data("repeat"));
        setValue("options.colors.bg", $(i).data("selectedcolor").replace("#", ""));
        setValue("options.backgroundSize", $(i).data("size"));
        $(i).find("a").text("Background set!");
        b.sync_settings();
        top.location.href = chrome.extension.getURL("newtab.html")
    }
    for (var g = 0; g < themeOptions.length; g++) {
        var f = themeOptions[g];
        var c = $("<div />");
        var a = $("<div />").css("background", "url(" + f.url + "),url(" + f.pattern + ")").css("background-repeat", f.repeat).css("background-position", f.position).css("background-size", f.type == "pattern" ? "original" : "contain").css("background-color", f.color).data("url", f.url).data("pattern", f.pattern).data("repeat", f.repeat).data("color", f.color).data("selectedcolor", f.color).data("position", f.position).data("size", f.size).data("customizable", f.customizable).click(function() {
            if (!$(this).find("a").size()) {
                d(this)
            }
        }).appendTo(c);
        c.addClass("theme-option").addClass(f.type).append("<span>" + f.name + "</span>");
        $("#themes").append(c)
    }
});
$(function() {
    $(".click-open-extension-page").click(function() {
        top.location.href = chrome.extension.getURL($(this).data("url"))
    });
    $(".click-explain-show").click(function() {
        $("#preview").hide();
        $("#explain").show()
    });
    $(".click-explain-hide").click(function() {
        $("#preview").show();
        $("#explain").hide()
    });
    $(".click-preview-shadow").click(function() {
        setValue("options.dialstyle.shadow", $(this).val());
        setPreview("shadow", $(this).val())
    });
    $(".click-preview-title-alignment").click(function() {
        var j = $(this).data("option");
        var i = $(this).data("value");
        setValue(j, i);
        setPreview("titlealign", i)
    });
    $(".click-set-value").click(function() {
        var j = $(this).data("option");
        var i = $(this).data("value");
        setValue(j, i)
    });
    $(".change-toggle-value").change(function() {
        var i = $(this).data("option");
        toggleValue(i)
    });
    $("#bookmarks-provider-none").click(function() {
        setBookmarksProvider(null)
    });
    $("#bookmarks-provider-chrome").click(function() {
        setBookmarksProvider("chrome")
    });
    $("#bookmarks-provider-delicious").click(function() {
        setBookmarksProvider("delicious")
    });
    $("#bookmarks-provider-google").click(function() {
        setBookmarksProvider("google")
    });
    $("#bookmarks-provider-pinboard").click(function() {
        setBookmarksProvider("pinboard")
    });
    $(".move-settings").click(function() {
        moveSettings($(this).data("direction"))
    });
    $("#show-more-patterns").click(function() {
        $(".pattern").addClass("featured");
        $(this).remove()
    });
    $(".modal-close").click(function() {
        $(this).parents(".modal").trigger("hide")
    });
    $("#import-settings-button").on("click", function() {
        $("#import-settings-warning").omniWindow({
            callbacks: {
                beforeShow: function(l, k) {
                    var j = l.modal.find("button[type=submit]");
                    var m = l.modal.find("input[type=checkbox]");
                    j.hide();
                    m.removeAttr("checked");
                    m.unbind().on("change", function() {
                        if ($(this).is(":checked")) {
                            j.show()
                        } else {
                            j.hide()
                        }
                    });
                    j.unbind().bind("click", function() {
                        l.modal.trigger("hide");
                        import_settings()
                    });
                    return k(l)
                }
            }
        }).trigger("show")
    });
    $(".save_settings_button").click(function() {
        b.sync_settings();
        top.location.href = chrome.extension.getURL("newtab.html")
    });
    $(".on_off").iphoneStyle({
        checkedLabel: "On",
        uncheckedLabel: "Off"
    });
    $("[rel=popover]").popover();
    $("[rel=tooltip]").tooltip();
    $(".radio").buttonset();
    var g = Math.floor(Math.random() * 11);
    if (g % 2 == 0) {
        var h = true;
        $("#support").addClass("cake")
    }
    $("#options-sync-password").hideShowPassword({
        innerToggle: true,
        hideToggleUntil: "focus"
    });
    $(".click-tab-sync").click(function() {
        tabsync()
    });
    if (location.hash == "#tab-sync" || location.hash == "#sync") {
        tabsync()
    }
    if (location.hash == "#design") {
        showSection("design")
    }
    $(".click-reset-thumbnail-ration").click(function() {
        resetThumbnailRatio()
    });
    $(".click-reset-background").click(function() {
        $("#options-background").val("");
        setValue("options.background", "")
    });
    var f = "";
    $(".become-pro").on("click", function() {
        $("#become-a-pro-modal").omniWindow().trigger("show")
    });
    var e = function(i) {
        f = i;
        $("#become-a-pro-modal").omniWindow().trigger("hide");
        $("#create-user-account").omniWindow().trigger("show");
        $("#create-user-account").find(".error-message").text("");
        $("#create-user-account").find(".btn").prop("disabled", false);
        $("#user-account-email").val("");
        $("#user-account-password").val("")
    };
    $("#pay-with-google").on("click", function() {
        e("google")
    });
    $("#pay-with-paypal").on("click", function() {
        e("paypal")
    });
    var a = function(i) {
        google.payments.inapp.buy({
            parameters: {
                env: "prod"
            },
            jwt: i.token,
            success: function(j) {
                if (window.console != undefined) {
                    console.log(j)
                }
                $("#create-user-account").omniWindow().trigger("hide");
                $("#payment-complete").omniWindow().trigger("show");
                $("#payment-complete").find("button").off().on("click", function() {
                    var k = JSON.parse(j.request.sellerData);
                    $("#payment-complete").omniWindow().trigger("hide");
                    $("#options-sync-username").val(k.email);
                    $("#options-sync-password").val(k.password);
                    $("#sync").click()
                })
            },
            failure: function(j) {
                if (window.console != undefined) {
                    console.log(j)
                }
                var k = $("#create-user-account").find(".error-message");
                switch (j.response.errorType) {
                    case "PURCHASE_CANCELED":
                        k.text("Your purchase was canceled.");
                        break;
                    case "MERCHANT_ERROR":
                        k.text("Merchant error.");
                        break;
                    case "POSTBACK_ERROR":
                        k.text("Merchant error.");
                        break;
                    default:
                        k.text("There was an error while processing your payment. No payment was made.");
                        break
                }
            }
        })
    };
    var d = function(j) {
        var l = j.paypal;
        setValue("options.sync.username", j.email);
        $("#paypal-form").remove();
        var i = $("<form />");
        i.attr("id", "paypal-form");
        i.attr("method", "post");
        i.attr("action", l.url);
        for (var k in l) {
            input = $("<input />");
            input.attr("type", "hidden");
            input.attr("name", k);
            input.attr("value", l[k]);
            input.appendTo(i)
        }
        i.appendTo("body");
        i.submit()
    };
    $("#create-user-account form").on("submit", function(o) {
        o.preventDefault();
        var n = $(this);
        var m = $(this).find("#user-account-email").val();
        var l = $(this).find("#user-account-password").val();
        var k = $(this).find(".error-message");
        k.text("");
        if (!m) {
            k.text("Please enter your e-mail.");
            return
        }
        if (!validateEmail(m)) {
            k.text("Please enter valid e-mail address.");
            return
        }
        if (!l) {
            k.text("Please enter your password.");
            return
        }
        n.find(".btn").prop("disabled", true);
        var j = {
            email: m,
            password: l
        };
        var i = chrome.extension.getBackgroundPage();
        i.get_user_token(j, function(p) {
            if (p.error) {
                k.text(p.error);
                n.find(".btn").prop("disabled", false);
                return
            } else {
                if (p.status == "ok" && p.token) {
                    if (f == "google") {
                        n.find(".btn").prop("disabled", false);
                        a(p)
                    } else {
                        if (f == "paypal") {
                            d(p)
                        }
                    }
                }
            }
        })
    });
    $("#logo-upload").click(function(i) {
        i.preventDefault();
        if (getValue("options.sync.username") && getValue("options.sync.password")) {
            c()
        }
    });
    $('a[rel="background_positioning"]').click(function() {
        switchTab("background_positioning")
    });
    $("#background_file .feature-locked a").click(function() {
        tabsync()
    });

    function c() {
        $("#upload-logo").click();
        $("#upload-logo").unbind().bind("change", function() {
            var j = this.files[0];
            if (j.size >= 2500 * 1024) {
                show_message("Sorry, this file too large.", true, 800);
                return
            }
            $("#background_file .progress-bar").show();
            var i = new FileReader();
            i.onload = function(l) {
                var k = chrome.extension.getBackgroundPage();
                k.upload(this.result, true, function(m) {
                    if (m.path != "") {
                        setValue("options.background", m.path);
                        setValue("options.backgroundPattern", "");
                        $("#background_file .msg.done").fadeIn(600)
                    } else {
                        if (r.error != "") {
                            show_message("Sorry, this file too large.", true, 800)
                        }
                    }
                    $("#background_file .progress-bar").hide()
                })
            };
            i.readAsDataURL(j)
        })
    }
});
