$(function() {
    $(".settings-icon").click(function() {
        $("#quick-options").addClass("shown")
    });
    $(".click-switch-dialog-null").click(function() {
        $(".dialog").removeClass("shown");
        setTimeout(function() {
            switchDialog(null)
        }, 300)
    });
    $(".click-clear-value").click(function() {
        $(this).val("")
    });
    $(".click-clear-search").click(function() {
        clearSearch(true)
    });
    $(".click-open").click(function() {
        openInCurrent($(this).data("url"))
    });
    $(".click-open-extension-page").click(function() {
        top.location.href = chrome.extension.getURL($(this).data("url"))
    });
    $(".click-set-value").click(function() {
        var c = $(this).data("option");
        var a = $(this).data("value");
        setValue(c, a);
        reload()
    });
    $("#options-centervertically").change(function() {
        toggleValue("options.centerVertically");
        reload()
    });
    $("#options-showAddButton").change(function() {
        toggleValue("options.showAddButton");
        reload()
    });
    $(document).on("click", "#delicious_close", function() {
        $(this).parent().hide()
    });
    $(document).on("click", "#click-restore-tabs", function() {
        restoreTabs()
    });
    if (getValue("options.sync.username") && getValue("options.sync.password")) {
        $("html").addClass("premium-user")
    } else {
        $("html").addClass("free-user")
    }
});
$.ajaxSetup({
    cache: false
});
if (localStorage["options.apps.show"] == 1 || localStorage["options.sidebar.showApps"]) {
    document.write('<script type="text/javascript" charset="utf-8" src="' + chrome.extension.getURL("js_system/apps.js") + '"><\/script>')
}
if (localStorage["options.sidebar"] == 1) {
    document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.js") + '"><\/script>');
    if (localStorage["options.sidebar.showBookmarks"] == 1) {
        document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.bookmarks.js") + '"><\/script>')
    }
    if (localStorage["options.sidebar.showHistory"] == 1) {
        document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.history.js") + '"><\/script>')
    }
    if (localStorage["options.sidebar.showDelicious"] == 1 && localStorage["options.sidebar.deliciousUsername"] != "") {
        document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.delicious.js") + '"><\/script>')
    }
    if (localStorage["options.sidebar.showPinboard"] == 1 && localStorage["options.sidebar.pinboardUsername"] != "") {
        document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.pinboard.js") + '"><\/script>')
    }
    if (localStorage["options.sidebar.showGooglebookmarks"] == 1) {
        document.write('<script src="' + chrome.extension.getURL("js_system/sidebar.gbookmarks.js") + '"><\/script>')
    }
}
var isCtrl = false;
$(window).keydown(function(a) {
    if (a.ctrlKey) {
        isCtrl = true
    }
}).keyup(function(a) {
    isCtrl = false
});
if (localStorage.firstTime != "false") {
    chrome.tabs.getSelected(null, function(a) {
        chrome.tabs.update(a.id, {
            url: chrome.extension.getURL("welcome.html")
        })
    })
}

function openInCurrent(a) {
    chrome.tabs.getSelected(null, function(c) {
        chrome.tabs.update(c.id, {
            url: a
        })
    })
}

function openInNew(a) {
    speeddial.storage.trackVisits(a);
    chrome.tabs.create({
        url: a,
        selected: false
    })
}

function openurl(a, c) {
    if (localStorage["options.alwaysNewTab"] == "1" && (isCtrl == true || c.which == 2)) {
        openInCurrent(a);
        c.preventDefault();
        c.stopPropagation()
    } else {
        if (localStorage["options.alwaysNewTab"] == "1") {
            chrome.tabs.create({
                url: a,
                selected: true
            });
            c.preventDefault()
        }
    }
}

function getThumbnail(a, c) {
    chrome.tabs.getSelected(null, function(d) {
        speeddial.storage.removeThumbnail(a);
        localStorage.requestThumbnail = d.id + "|||" + a;
        openInCurrent(a)
    })
}
var dialog_mode;

function removeDial() {
    var c = $("#url-dialog #bookmark_id").val();
    var a = $("li#" + c);
    resetDialog();
    return removeBookmark(a)
}

function removeBookmark(a) {
    url = a.attr("url");
    id = a.attr("id");
    speeddial.storage.removeThumbnail(url);
    speeddial.storage.deleteItem(id);
    a.animate({
        opacity: 0
    }, 300, function() {
        a.remove()
    });
    //speeddial.storage.analytics("removed-bookmark");
    //_gaq.push(["_trackEvent", "Bookmarks", "Removed bookmark"])
}

function removeGroup() {
    var a = $("#url-dialog #bookmark_id").val();
    speeddial.storage.deleteGroup(a);
    resetDialog();
    show_message(i18n("new_tab_group_removed"));
    $("[loadgroup=" + a + "]").remove();
    if (GROUP == a) {
        GROUP = 0;
        if (localStorage["options.keepActiveGroup"] == 1) {
            localStorage["options.activeGroup"] = 0
        }
        window.location.hash = "";
        reload()
    }
    //speeddial.storage.analytics("removed-group");
    //_gaq.push(["_trackEvent", "Bookmarks", "Removed group"])
}

function clearDialog() {
    dialog_mode = "";
    $("#url-dialog #name").val("");
    $("#url-dialog #url").val("");
    $("#url-dialog #bookmark_id").val("");
    $("#url-dialog #color").val("FFFFFF").css("background-color", "#FFFFFF");
    $("#url-dialog #thumbnail").val("");
    $("#url-dialog-groups").val(GROUP);
    setLogoPreview(null)
}

function suggestUrl() {
    if ($("body.history-searched").length == 0) {
        chrome.history.search({
            text: "",
            maxResults: 5000,
            startTime: 0
        }, function(d) {
            var f = new Array();
            var e = [];
            var j = [];
            var a = [];
            var g;
            for (var c = 0; c < d.length; ++c) {
                if (typeof d[c].url != "undefined" && d[c].url.indexOf("chrome-extension") < 0) {
                    g = getHostname(d[c].url);
                    if (g) {
                        if (!a[g]) {
                            a[g] = 1;
                            j.push([g])
                        }
                    }
                }
            }
            $("body").addClass("history-searched");
            $("#url").autocomplete(j, {
                max: 7,
                autoFill: false,
                selectFirst: false,
                matchContains: true,
                formatItem: function(h) {
                    return h[0]
                },
                formatResult: function(h) {
                    return h[0]
                }
            })
        })
    }
}

function resetDialog() {
    return switchDialog(null)
}

function switchDialog(a) {
    $(".uipart").hide(0);
    $("#url-dialog").removeClass("show-website-selector");
    $("#url-dialog .website-selector").hide();
    switch (a) {
        case "add":
            clearDialog();
            suggestUrl();
            $(".add_dialog_label").show();
            $(".url-dialog-url").show();
            $(".logo-container").show();
            $("#url-dialog .tab").removeClass("active");
            $("#url-dialog .capture-explain").show();
            $("#url-dialog").addClass("shown");
            $("#url-dialog-thumbnail").show();
            $("#url-dialog-group").show();
            $("#url-dialog-name").show();
            setTimeout(function() {
                $("#url-dialog #url").focus()
            }, 200);
            break;
        case "edit":
            $(".url-dialog-url").show();
            $("#url-dialog-thumbnail").show();
            $(".logo-container").show();
            $("#url-dialog-group").show();
            $("#url-dialog-name").show();
            $(".edit_dialog_label").show();
            suggestUrl();
            break;
        case "editgroup":
            $("#url-dialog .group_edit").show();
            $("#url-dialog-color").show();
            $("#url-dialog-name").show();
            $("#url-dialog").addClass("shown");
            break;
        case "removegroup":
            $("#url-dialog .group_delete").show();
            $("#url-dialog-name").hide();
            $("#url-dialog").addClass("shown");
            break;
        case "removedial":
            $("#url-dialog .bookmark_delete").show();
            $("#url-dialog-name").hide();
            $("#url-dialog").addClass("shown");
            break;
        case "create_group":
            $("#url-dialog .group_add").show();
            $("#url-dialog-color").show();
            $("#url-dialog-name").show();
            $("#url-dialog").addClass("shown");
            setTimeout(function() {
                $("#url-dialog #name").focus()
            }, 200);
            break;
        default:
            $("#url-dialog").removeClass("shown");
            clearDialog();
            break
    }
    dialog_mode = a
}

function prepareDialog(c, a) {
    clearDialog();
    switchDialog(c);
    switch (c) {
        case "edit":
            speeddial.storage.getItem(a, editDialog);
            break;
        case "editgroup":
            if (a > 0) {
                speeddial.storage.getGroup(a, editGroupDialog)
            } else {
                if (a == 0) {
                    editGroupDialog(null, null)
                }
            }
            break;
        case "removegroup":
            $("#url-dialog #bookmark_id").val(a);
            break;
        case "removedial":
            $("#url-dialog #bookmark_id").val(a);
            break
    }
}
var previous;
var previous_thumbnail;

function editDialog(a, c) {
    current = c.rows.item(0);
    previous = current.url;
    previous_thumbnail = current.thumbnail;
    $("#url-dialog #name").val(current.title);
    $("#url-dialog .thumbnail-options button").removeClass("selected");
    $("#url-dialog .tab").removeClass("active");
    if (current.thumbnail) {
        setLogoPreview(current.thumbnail);
        if (current.thumbnail.indexOf("flickr.com") > -1) {} else {
            if (current.thumbnail.indexOf("speeddial2.com") > -1) {} else {
                switchTab("logo-custom-url")
            }
        }
    } else {
        var d = $("#" + current.id).find(".thumbnail_container").css("background-image").replace("url(", "").replace(")", "");
        setLogoPreview(null);
        switchTab("logo-capture")
    }
    $("#url-dialog #url").val(decodeURI(current.url));
    $("#url-dialog #thumbnail").val(current.thumbnail);
    $("#url-dialog #bookmark_id").val(current.id);
    $("#url-dialog").addClass("shown");
    $("#url-dialog #url").focus()
}

function editGroupDialog(a, c) {
    if (a === null && c === null) {
        current = [];
        current.id = 0;
        current.title = localStorage["options.defaultGroupName"];
        current.color = localStorage["options.defaultGroupColor"]
    } else {
        current = c.rows.item(0)
    }
    $("#url-dialog #name").val(current.title);
    $("#url-dialog #bookmark_id").val(current.id);
    document.getElementById("color").color.fromString(current.color);
    $("#url-dialog #name").focus()
}

function createGroupDialog() {
    $("#url-dialog #name").val("");
    document.getElementById("color").color.fromString("FFFFFF");
    $("#url-dialog #name").focus()
}

function fixUrl(a) {
    if ((a.indexOf("http://") != 0) && (a.indexOf("https://") != 0) && (a.indexOf("smtp://") != 0) && (a.indexOf("ftp://") != 0) && (a.indexOf("rtp://") != 0) && (a.indexOf("irc://") != 0) && (a.indexOf("file://") != 0) && (a.indexOf("chrome://") != 0) && (a.indexOf("chrome-extension") < 0) && (a.indexOf("snmp://") != 0)) {
        a = "http://" + a
    }
    return a
}

function openAllLinks(a, c) {
    for (var d = 0; d < c.rows.length; d++) {
        speeddial.storage.trackVisits(c.rows.item(d).url);
        chrome.tabs.create({
            url: c.rows.item(d).url,
            selected: false
        })
    }
}

function openAllFromGroup(a) {
    GROUP = a;
    speeddial.storage.getAllItems(openAllLinks, a)
}

function encodeInNeed(a) {
    if (a.indexOf("%") > -1) {
        return a
    }
    return encodeURI(a)
}

function addBookmark() {
    insert = new Array();
    insert.title = $("#add-edit-dialog #name").val();
    insert.url = encodeInNeed($("#add-edit-dialog #url").val());
    insert.thumbnail = $("#add-edit-dialog #thumbnail").val();
    insert.ts_created = Math.round(new Date().getTime() / 1000);
    insert.visits = 0;
    insert.visits_morning = 0;
    insert.visits_afternoon = 0;
    insert.visits_evening = 0;
    insert.visits_night = 0;
    insert.position = 999;
    if (parseInt($("#url-dialog-groups").val()) >= 0) {
        insert.idgroup = parseInt($("#url-dialog-groups").val())
    } else {
        insert.idgroup = 0
    }
    insert.url = fixUrl(insert.url);
    if (!insert.title || !insert.url) {
        show_message(i18n("new_tab_add_dial_error"));
        return false
    }
    speeddial.storage.addItem(insert, reload);
    resetDialog();
    if ($(".first-dial")) {
        $(".first-dial").remove()
    }
    //speeddial.storage.analytics("created-bookmark");
    //_gaq.push(["_trackEvent", "Bookmarks", "Created bookmark"])
}

function editBookmark() {
    id = parseInt($("#add-edit-dialog #bookmark_id").val());
    title = $("#add-edit-dialog #name").val();
    url = encodeInNeed($("#add-edit-dialog #url").val());
    thumbnail = $("#add-edit-dialog #thumbnail").val();
    if (parseInt($("#url-dialog-groups").val()) >= 0) {
        var d = parseInt($("#url-dialog-groups").val())
    }
    var a=true;
    if (id < 0 || !title || !url) {
        show_message(i18n("new_tab_add_dial_error"));
        return false
    }
    if (previous != url) {
        speeddial.storage.removeThumbnail(previous);
        a = true
    }
    if (previous_thumbnail == "" && thumbnail != "") {
        speeddial.storage.removeThumbnail(previous)
    } else {
        a = false
    }
    var c = new Array();
    c.id = id;
    c.title = title;
    c.url = url;
    c.thumbnail = thumbnail;
    c.url = fixUrl(c.url);
    c.idgroup = d;
    speeddial.storage.editItem(c, a);
    resetDialog();
    show_message(i18n("new_tab_dial_saved"));
    //speeddial.storage.analytics("edited-bookmark")
}

function editGroup() {
    id = parseInt($("#url-dialog #bookmark_id").val());
    title = $("#url-dialog #name").val();
    color = $("#url-dialog #color").val();
    if (parseInt(id) < 0 || !title) {
        show_message(i18n("new_tab_enter_group_name"));
        return false
    }
    if (id == 0) {
        localStorage["options.defaultGroupName"] = title;
        localStorage["options.defaultGroupColor"] = color;
        resetDialog();
        reload();
        return true
    }
    var a = new Array();
    a.id = id;
    a.title = title;
    a.color = color;
    speeddial.storage.editGroup(a, true);
    resetDialog();
    show_message(i18n("new_tab_group_edited"),true);
    //speeddial.storage.analytics("edited-group");
    //_gaq.push(["_trackEvent", "Bookmarks", "Edited group"])
}

function addGroup() {
    title = $("#url-dialog #name").val();
    color = $("#url-dialog #color").val();
    if (!title) {
        show_message(i18n("new_tab_enter_group_name"));
        return false
    }
    var a = new Array();
    a.title = title;
    a.color = color;
    speeddial.storage.addGroup(a, function() {
        resetDialog();
        show_message(i18n("new_tab_group_edited"));
        reload()
    });
    //speeddial.storage.analytics("created-group");
    //_gaq.push(["_trackEvent", "Bookmarks", "Created group"])
}

function moveToGroup(a, c) {
    speeddial.storage.moveToGroup(a, c, reload)
}

function switchTab(a) {
    $(".thumbnail-options button").removeClass("selected");
    $(".thumbnail-options button[rel=" + a + "]").addClass("selected");
    $("#url-dialog .tab").removeClass("active");
    $("#url-dialog #" + a).addClass("active");
    if (a == "logo-upload") {
        if (getValue("options.sync.username") && getValue("options.sync.password")) {
            upload_file()
        } else {
            $("#url-dialog .feature-locked a").attr("href", chrome.extension.getURL("options.html#tab-sync"));
            $("#url-dialog .feature-locked").show()
        }
    }
    if (a == "logo-popular") {
        if ($("#url-dialog #url").val() == "") {
            $("#url-dialog").addClass("show-website-selector");
            $("#url-dialog .website-selector").show()
        }
    }
}

function reorderBookmarks() {
    var a = $("#pages li.link");
    var d = {};
    for (var c = 0; c < a.length; c++) {
        id = $(a[c]).attr("id");
        pos = c;
        speeddial.storage.updateItemOrder(id, pos);
        d[id] = pos
    }
    b.sync_order_bookmarks(d)
}

function pagesOnLoad() {
    $("[rel=tooltip]").tooltip({
        animation: true
    });
    $("#groups li").click(function(a) {
        if (SORTINGGROUPS === false) {
            if (a.which == "2") {
                openAllFromGroup($(this).attr("loadgroup"));
                a.preventDefault();
                a.stopPropagation();
                return false
            } else {
                GROUP = $(this).attr("loadgroup");
                window.location.hash = "#" + GROUP;
                scroll(0, 0);
                if (localStorage["options.keepActiveGroup"] == 1) {
                    localStorage["options.activeGroup"] = GROUP
                }
                reload();
                a.preventDefault();
                a.stopPropagation();
                return false
            }
        }
    });
    $(".link").click(function(a) {
        $this = $(this);
        if (SORTING === false) {
            localStorage.refreshThumbnail = "";
            if ($this.hasClass("no-thumbnail")) {
                speeddial.storage.trackVisits($this.attr("url"));
                getThumbnail($this.attr("url"), false);
                a.preventDefault();
                a.stopPropagation();
                return false
            }
            if (localStorage["options.alwaysNewTab"] == 1 || (localStorage["options.alwaysNewTab"] != "1" && (isCtrl != true || a.which != 2))) {
                if (localStorage["options.refreshThumbnails"] > 0) {
                    if ($this.attr("custom_thumbnail") != "true" && ($this.attr("visits")) % (localStorage["options.refreshThumbnails"]) == 0) {
                        localStorage.refreshThumbnail = $this.attr("url")
                    }
                }
            }
            if (a.which != 3) {
                speeddial.storage.trackVisits($this.attr("url"))
            }
            if (localStorage["options.alwaysNewTab"] == "1" && (isCtrl == true || a.which == 2)) {
                openInCurrent($this.attr("url"));
                a.preventDefault();
                a.stopPropagation()
            } else {
                if (localStorage["options.alwaysNewTab"] == "1") {
                    chrome.tabs.create({
                        url: $this.attr("url"),
                        selected: true
                    });
                    a.preventDefault()
                }
            }
            if (navigator.appVersion.indexOf("Mac") != -1) {
                if ((isCtrl == true || a.which == 2) && localStorage["options.alwaysNewTab"] != 1) {
                    openInNew($this.attr("url"));
                    a.preventDefault();
                    a.stopPropagation()
                }
            }
        } else {
            return false
        }
    });
    $(".link:not(.folder)").contextMenu("editlinkmenu", {
        menuStyle: {
            border: "1px solid #ccc"
        },
        onContextMenu: function(a) {
            page_edit_id = $(a.target).attr("rel");
            return true
        },
        bindings: {
            opennewwindow: function(a) {
                openInNew($(a).attr("url"))
            },
            refresh: function(a) {
                getThumbnail($(a).attr("url"), true)
            },
            "delete": function(a) {
                prepareDialog("removedial", $(a).attr("id"))
            },
            edit: function(a) {
                prepareDialog("edit", $(a).attr("id"))
            },
        }
    });
    $('#groups li:not(".home")').contextMenu("editgroupmenu", {
        menuStyle: {
            border: "1px solid #ccc"
        },
        onContextMenu: function(a) {
            page_edit_id = $(a.target).attr("rel");
            return true
        },
        bindings: {
            editgroup: function(a) {
                prepareDialog("editgroup", $(a).attr("loadgroup"))
            },
            openallgroup: function(a) {
                openAllFromGroup($(a).attr("loadgroup"))
            },
            deletegroup: function(a) {
                prepareDialog("removegroup", $(a).attr("loadgroup"))
            }
        }
    });
    $("#groups li.home").contextMenu("edithomegroupmenu", {
        menuStyle: {
            border: "1px solid #ccc"
        },
        bindings: {
            editgroup: function(a) {
                prepareDialog("editgroup", 0)
            },
            openallgroup: function(a) {
                openAllFromGroup($(a).attr("loadgroup"))
            }
        }
    });
    $(".app, #appspanel li").not("no-uninstall").contextMenu("editappmenu", {
        menuStyle: {
            border: "1px solid #ccc"
        },
        onContextMenu: function(a) {
            $this = $(a.target).parents("li");
            app_edit_id = $this.attr("rel");
            if ($this.data("uninstall") == false) {
                $("#app_uninstall").hide()
            } else {
                $("#app_uninstall").show()
            }
            if ($this.data("options") != "") {
                $("#app_options").css("color", "#000")
            } else {
                $("#app_options").css("color", "#999")
            }
            return true
        },
        bindings: {
            app_launch: function(a) {
                launchApp($(a).attr("rel"))
            },
            app_options: function(a) {
                if ($(a).data("options") != "") {
                    openInCurrent($(a).data("options"))
                }
            },
            app_uninstall: function(a) {
                appUninstall($(a).attr("rel"), a)
            }
        }
    });
    $("#container").contextMenu("newitemmenu", {
        menuStyle: {
            border: "1px solid #ccc"
        },
        bindings: {
            add: function(a) {
                prepareDialog("add", null)
            },
            create_group: function(a) {
                prepareDialog("create_group", null)
            },
            options: function(a) {
                top.location.href = chrome.extension.getURL("options.html")
            },
            statistics: function(a) {
                top.location.href = chrome.extension.getURL("statistics.html")
            },
            help: function(a) {
                top.location.href = chrome.extension.getURL("welcome.html")
            }
        }
    });
    setTimeout(function() {
        if (localStorage["options.order"] == "position") {
            var c = false
        } else {
            var c = true
        }
        if (localStorage["options.order"] == "visits") {
            var d = $("#pages li");
            for (var e = d.length - 1; e >= 0; e--) {
                var a = $(d[e]).offset();
                $(d[e]).css("position", "absolute");
                $(d[e]).css("top", a.top);
                $(d[e]).css("left", a.left);
                $(d[e]).attr("top", a.top);
                $(d[e]).attr("left", a.left)
            }
        }
        if ($("#groups li").length > 0 || localStorage["options.order"] == "position") {
            $("#pages").sortable({
                delay: 100,
                tolerance: "pointer",
                connectWith: ".group",
                appendTo: "body",
                placeholder: "pagesplaceholder",
                forcePlaceholderSize: true,
                start: function(g, h) {
                    SORTING = true;
                    $(h.item).addClass("beingdragged");
                    if ($("#groups li").length > 0) {
                        var f = $("#pages").offset();
                        $("#pages").css({
                            position: "absolute",
                            top: $("#groups").height(),
                            left: f.left
                        });
                        $("#groups").css("position", "fixed")
                    }
                },
                stop: function(f, g) {
                    $(g.item).removeClass("beingdragged");
                    $(g.item).css("top", $(g.item).attr("top"));
                    $(g.item).css("left", $(g.item).attr("left"));
                    setTimeout(function() {
                        SORTING = false
                    }, 200);
                    if ($("#groups li").length > 0) {
                        $("#groups").css("position", "fixed");
                        $("#pages").css({
                            position: "relative",
                            top: 0,
                            left: 0
                        })
                    }
                    if (localStorage["options.order"] == "position") {
                        reorderBookmarks()
                    }
                }
            });
            $(".group").droppable({
                accept: ".link",
                tolerance: "pointer",
                over: function(f, g) {
                    $(".group").removeClass("hovered");
                    $(this).addClass("hovered")
                },
                out: function(f, g) {
                    $(".group").removeClass("hovered")
                },
                drop: function(h, i) {
                    var f = $(this).parent().attr("loadgroup");
                    var g = $(i.draggable).attr("id");
                    if (parseInt(f) >= 0) {
                        moveToGroup(g, f);
                        $(i.draggable).remove()
                    }
                    $("footer").animate({
                        opacity: 1
                    }, 50, function() {
                        SORTING = false
                    })
                },
            });
            $("#groups").sortable({
                delay: 100,
                axis: "x",
                placeholder: "groupsplaceholder",
                tolerance: "intersect",
                start: function(f, g) {
                    SORTINGGROUPS = true
                },
                stop: function(h, k) {
                    $("#message").animate({
                        opacity: 1
                    }, 50, function() {
                        SORTINGGROUPS = false
                    });
                    var j = $("#groups li");
                    var g = {};
                    for (var f = 0; f < j.length; f++) {
                        g[$(j[f]).attr("loadgroup")] = f + 1;
                        speeddial.storage.setGroupPosition($(j[f]).attr("loadgroup"), f + 1)
                    }
                    b.sync_order_groups(g);
                    return true
                }
            })
        }
    }, 10)
}

function setLogoPreview(a) {
    if (null !== a && a != "") {
        $("#url-dialog .logo-container").removeClass("no-thumbnail").find("div").css("background-image", "url(" + a + ")")
    } else {
        $("#url-dialog .logo-container").addClass("no-thumbnail")
    }
}

function loadPopularLogos() {
    $("#logo li").each(function() {
        $this = $(this);
        $this.data("name", $this.text()).text("");
        $this.css("background-image", "url(" + $this.data("url") + ")")
    })
}

function upload_file() {
    $("#upload-logo").click();
    $("#upload-logo").unbind().bind("change", function() {
        var c = this.files[0];
        if (c.size >= 2500 * 1024) {
            show_message("Sorry, this file too large.", true, 800);
            return
        }
        $("#url-dialog .feature-allowed").show();
        var a = new FileReader();
        a.onload = function(f) {
            var d = chrome.extension.getBackgroundPage();
            d.upload(this.result, false, function(e) {
                if (e.path != "") {
                    setLogoPreview(e.path);
                    $("#thumbnail").val(e.path)
                } else {
                    if (r.error != "") {
                        show_message("Sorry, this file too large.", true, 800)
                    }
                }
                $("#url-dialog .feature-allowed").hide()
            })
        };
        a.readAsDataURL(c)
    })
}
$(function() {
    init();
    loadPopularLogos();
    $("*[i18n]").each(function() {
        $(this).html(i18n($(this).attr("i18n")))
    });
    $("#add_bookmark").click(function() {
        addBookmark();
        return false
    });
    $("#edit_bookmark").click(function() {
        editBookmark();
        return false
    });
    $("#new-bookmark-link").click(function() {
        prepareDialog("add", null)
    });
    $("#url-dialog .logo-container a").click(function() {
        setLogoPreview(null);
        $("#thumbnail").val("")
    });
    $("#thumbnail").blur(function() {
        setLogoPreview($("#thumbnail").val())
    });
    $("#save_group").click(function() {
        addGroup();
        return false
    });
    $("#edit_group").click(function() {
        editGroup();
        return false
    });
    $("#add_group").click(function() {
        addGroup();
        return false
    });
    $("#delete_group").click(function() {
        removeGroup();
        return false
    });
    $("#delete_dial").click(function() {
        removeDial();
        return false
    });
    $(".url-dialog-url .url-selector").click(function() {
        $("#url-dialog #url").val("");
        $("#url-dialog #name").val("");
        setLogoPreview(null);
        switchTab("logo-popular")
    });
    $("#url-dialog .website-selector .btn").click(function() {
        $("#url-dialog").removeClass("show-website-selector");
        $("#url-dialog .website-selector").hide();
        $("#url-dialog .tab").removeClass("active")
    });
    $("#logo li").click(function() {
        if (!$("#url-dialog #url").val()) {
            $("#url-dialog #url").val($(this).data("href"));
            $("#url-dialog #name").val($(this).data("name"))
        }
        $("#url-dialog .tab").removeClass("active");
        $("#thumbnail").val($(this).data("url"));
        setLogoPreview($(this).data("url"));
        if ($("#url-dialog").hasClass("show-website-selector")) {
            $("#url-dialog #url").val($(this).data("href"));
            $("#url-dialog #name").val($(this).data("name"));
            if (dialog_mode == "add") {
                $("#add_bookmark").click()
            } else {
                if (dialog_mode == "edit") {
                    $("#edit_bookmark").click()
                }
            }
        }
    });
    $("#overlay").click(function() {
        if ($("#quick-options").hasClass("shown")) {
            console.log("Saving settings");
            b.sync_settings()
        }
        $(".dialog").removeClass("shown")
    });
    $("#quick-options .close").click(function() {
        console.log("Saving settings");
        b.sync_settings();
        $(".dialog").removeClass("shown")
    });
    $("#url-dialog .close").click(function() {
        resetDialog()
    });
    $(".close").click(function() {
        $(this).parents(".dialog").removeClass("shown");
        resetDialog()
    });
    $("input").attr("autocomplete", "off");
    $("a.ext").attr("target", "_blank");
    $(document).on("click", ".openurl", function(d) {
        openurl($(this).attr("rel"), d)
    });
    $("#add-edit-dialog").keydown(function(d) {
        if (d.keyCode == 13) {
            if ($("#url:focus").length > 0) {
                return false
            }
            if (dialog_mode == "add") {
                $("#add_bookmark").click()
            } else {
                if (dialog_mode == "edit") {
                    $("#edit_bookmark").click()
                }
            }
            d.preventDefault()
        } else {
            if (d.keyCode == 27) {
                resetDialog()
            }
        }
    });
    $("#add-edit-dialog #url").blur(function() {
        if (dialog_mode == "add") {
            $("#add-edit-dialog #name").val("")
        }
    });
    $("#add-edit-dialog #name").focus(function() {
        if (dialog_mode == "add") {
            if ($(this).val() == "" && $("#add-edit-dialog #url").val().length < 20) {
                var d = $("#add-edit-dialog #url").val();
                d = d.replace("http://", "").replace(".org", "").replace(".com", "").replace(".net", "").replace("www.", "").replace("/", ".");
                d = d.charAt(0).toUpperCase() + d.slice(1);
                $("#add-edit-dialog #name").val(d)
            }
        }
    });
    var c = window.innerWidth;
    var a = window.innerHeight;
    setTimeout(function() {
        window.addEventListener("resize", function() {
            if (Math.abs(window.innerWidth - c) > 100 || Math.abs(window.innerHeight - a) > 100) {
                reload();
                c = window.innerWidth;
                a = window.innerHeight
            }
        }, false)
    }, 360)
});
$(function() {
    if (getValue("options.columns") >= 0) {
        $("#options-columns").val(getValue("options.columns"));
        $("#options-columns-val").val(getValue("options.columns"))
    }
    $("#options-columns").change(function() {
        $("#options-columns-val").val($(this).val());
        setValue("options.columns", $(this).val());
        reload()
    });
    if (getValue("options.dialspacing") >= 0) {
        $("#options-dialspacing").val(getValue("options.dialspacing"));
        $("#options-dialspacing-val").val(getValue("options.dialspacing"))
    }
    $("#options-dialspacing").change(function() {
        $("#options-dialspacing-val").val($(this).val());
        setValue("options.dialspacing", $(this).val());
        reload()
    });
    if (getValue("options.dialSpace") >= 0) {
        $("#options-dialspace").val(getValue("options.dialSpace"));
        $("#options-dialspace-val").val(getValue("options.dialSpace"))
    }
    $("#options-dialspace").change(function() {
        $("#options-dialspace-val").val($(this).val());
        setValue("options.dialSpace", $(this).val());
        reload()
    });
    if (getValue("options.showAddButton") == 1) {
        $("#options-showAddButton").attr("checked", true)
    }
    if (getValue("options.centerVertically") == 1) {
        $("#options-centervertically").attr("checked", true)
    }
    switch (getValue("options.scrollLayout")) {
        case "0":
            $("#options-scrollLayout0").attr("checked", true);
            break;
        default:
            $("#options-scrollLayout1").attr("checked", true)
    }
    $(".thumbnail-options button").click(function(a) {
        a.preventDefault();
        switchTab($(this).attr("rel"))
    });
    $(".on_off").iphoneStyle({
        checkedLabel: "On",
        uncheckedLabel: "Off"
    });
    $(".radio").buttonset();
    //getNews();
    //showNews()
});
/*
var _gaq = _gaq || [];
_gaq.push(["_setAccount", "UA-1391454-40"]);
_gaq.push(["_setCustomVar", 1, "User-type", (localStorage["options.sync.password"] && localStorage["options.sync.username"]) ? "Pro" : "Regular", 1]);
_gaq.push(["_setCustomVar", 2, "Using Groups", localStorage["sys.groups"] > 0 ? "Yes" : "No", 1]);
_gaq.push(["_trackEvent", "Extension", "Opened New tab"]);
_gaq.push(["_trackPageview"]);
(function() {
    var c = document.createElement("script");
    c.type = "text/javascript";
    c.async = true;
    c.src = "https://ssl.google-analytics.com/ga.js";
    var a = document.getElementsByTagName("script")[0];
    a.parentNode.insertBefore(c, a)
})();
speeddial.storage.analytics("opens");
*/